package fighter

import (
	"fmt"
	"math/rand"
	"time"
)

type Fighter struct {
	name         string
	health       byte
	strength     byte
	intelligence byte
	dexterity    byte
	speed        byte
}

// Инициализация бойца. Принимает имя, генерирует его характеристики
func (f *Fighter) InitFighter(name string) {
	f.name = name
	f.health = 50 + getRandomByte(120)

	f.strength = getRandomByte()
	f.strength = getRandomByte(201)
	f.intelligence = getRandomByte()
	f.dexterity = getRandomByte()
	f.speed = getRandomByte()

}

func (f *Fighter) Name() string {
	return f.name
}

func (f *Fighter) Health() byte {
	return f.health
}

func (f *Fighter) Characteristics() string {
	return fmt.Sprintf("здоровье: %d\nсила: %d\nинтелект: %d\nловкость: %d\n",
		f.health, f.strength, f.intelligence, f.dexterity)
}

// Возвращает число от 0 до 254, если передан n, то от 0 до n
// Если n больше 254, то оно игнорируется
func getRandomByte(n ...int) byte {
	rand.Seed(time.Now().UnixNano())
	var max int = 255

	if len(n) == 1 && n[0] < 255 {
		max = n[0]
	}

	return byte(rand.Intn(max))
}

// Возвращает случайное имя бойца
func ChooseRandomFighterName() string {
	rand.Seed(time.Now().UnixNano())
	var max int = len(names)
	return names[rand.Intn(max)]
}

// Возвращает список из имен, которые выбраны случайным образом
func GetRandomNames(count int) []string {
	rand.Seed(time.Now().UnixNano())

	var max int = len(names) - 1
	var resultNames []string

	for i := 0; i < count; i++ {
		resultNames = append(resultNames, names[rand.Intn(max)])
	}

	return resultNames
}
