package main

import (
	"fight_club/cmd/fight_club/fighter"
	"fmt"
	"log"
	"os"
)

// Главный модуль. Просит выбрать бойца, начинает драку.
func main() {
	var res int

	var chooseFrom int = 3
	randNames := fighter.GetRandomNames(chooseFrom)
	for number, name := range randNames {
		fmt.Printf("%d. %v\n", number+1, name)
	}

	fmt.Printf("Выбери своего бойца (введи его номер): ")
	_, err := fmt.Scanf("%d", &res)

	// Проверяем ввод
	if err != nil || res <= 0 || res > chooseFrom {
		log.Fatal("Ты выбираешь не правильно, можно только числа от 1 до ", chooseFrom)
		os.Exit(1)

	}

	var frst, scnd fighter.Fighter
	frst.InitFighter(randNames[res-1])
	scnd.InitFighter(fighter.ChooseRandomFighterName())

	fmt.Println("В бою учавствуют:")
	fmt.Printf("(*) %v\n%v\n", frst.Name(), frst.Characteristics())

	fmt.Printf("( ) %v\n%v\n", scnd.Name(), scnd.Characteristics())

	winner := fighter.StartFight(&frst, &scnd)

	fmt.Println()

	if winner == &frst {
		fmt.Println("Твой боец победил!")
	} else {
		fmt.Println("Твой боец проиграл!")
	}

	fmt.Printf("Победил %v, у него осталось %d HP\n", winner.Name(), winner.Health())

}
